﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
namespace SearchingMvc.Models
{
    # region Models
    public class Student
    {
        #region Properties
        /// <summary>
        /// Gets or sets the University Code 
        /// </summary>
        public long UniversityCode { get; set; }
        /// <summary>
        /// Gets or sets the course title
        /// </summary>
        public string Title { get; set; }
        /// <summary>
        /// Gets or sets the duration in days of the course
        /// </summary>                
        public int Duration { get; set; }
        /// <summary>
        /// Gets or sets course fees
        /// </summary>        
        public double CourseFees { get; set; }
        /// <summary>
        /// Gets or sets CGPA
        /// </summary>        
        public double CGPA { get; set; }
        #endregion
    }
    public class StudentDataContext
    {
        #region Properties
        /// <summary>
        /// Gets  the courses in a IQueryable format
        /// </summary>
        public List<Student> Student
        {
            get
            {
                List<Student> student = new List<Student>();
                Student stu = new Student();
                int code = 10000;
                for (long i = 0; i < 1200; i++)
                {
                    Student[] s = new Student[10];
                    s[0] = new Student() { UniversityCode = code + 1, CourseFees = 2000.00, CGPA = 7.52, Duration = 90, Title = "Distributed Component Architecture" };
                    s[1] = new Student() { UniversityCode = code + 2, CourseFees = 1000.00, CGPA = 9.55, Duration = 60, Title = "Data Structures" };
                    s[2] = new Student() { UniversityCode = code + 3, CourseFees = 1750.00, CGPA = 9.03, Duration = 75, Title = "Neural Networks" };
                    s[3] = new Student() { UniversityCode = code + 4, CourseFees = 2000.00, CGPA = 8.91, Duration = 90, Title = "Genetic Algorithms" };
                    s[4] = new Student() { UniversityCode = code + 5, CourseFees = 1000.00, CGPA = 9.55, Duration = 30, Title = "Grid Computing" };
                    s[5] = new Student() { UniversityCode = code + 6, CourseFees = 2500.00, CGPA = 9.87, Duration = 60, Title = "Cloud Computing" };
                    s[6] = new Student() { UniversityCode = code + 7, CourseFees = 1500.00, CGPA = 9.75, Duration = 90, Title = "Enterprise Computing" };
                    s[7] = new Student() { UniversityCode = code + 8, CourseFees = 1250.00, CGPA = 9.66, Duration = 45, Title = "Mobile Computing" };
                    s[8] = new Student() { UniversityCode = code + 9, CourseFees = 1000.00, CGPA = 8.33, Duration = 60, Title = "WAP and XML" };
                    s[9] = new Student() { UniversityCode = code + 10, CourseFees = 1500.00, CGPA = 8.66, Duration = 75, Title = "Design Patterns" };
                    foreach (Student studnt in s)
                    {
                        student.Add(studnt);
                    }
                    code += 10;
                }
                return student;
            }
        }
        #endregion
    }
    public class OrderRepository
    {
        public static IList<Student> GetAllRecords()
        {
            IList<Student> orders = (IList<Student>)HttpContext.Current.Session["Student Details"];
            if (orders == null)
            {
                HttpContext.Current.Session["Student Details"] = orders = (from ord in new StudentDataContext().Student.Take(100)
                                                                           select new Student { UniversityCode = ord.UniversityCode, Title = ord.Title, Duration = ord.Duration, CourseFees = ord.CourseFees, CGPA = ord.CGPA }).ToList();
            }
            return orders;
        }
        public static void Add(Student order)
        {
            GetAllRecords().Insert(0, order);
        }
        public static void Add(IEnumerable<Student> orders)
        {
            foreach (var order in orders)
            {
                GetAllRecords().Insert(0, order);
            }
        }
        public static Student Select(long? UniversityCode)
        {
            Student result = GetAllRecords().Where(o => o.UniversityCode == UniversityCode).FirstOrDefault(); return result;
        }
        public static void Delete(long UniversityCode)
        {
            Student result = GetAllRecords().Where(o => o.UniversityCode == UniversityCode).FirstOrDefault(); GetAllRecords().Remove(result);
        }
        public static void Delete(IEnumerable<Student> orders)
        {
            foreach (var res in orders)
            {
                Student result = GetAllRecords().Where(o => o.UniversityCode == res.UniversityCode).FirstOrDefault(); GetAllRecords().Remove(result);
            }
        }
        public static void Update(Student order)
        {
            Student result = GetAllRecords().Where(o => o.UniversityCode == order.UniversityCode).FirstOrDefault();
            if (result != null)
            {
                result.UniversityCode = order.UniversityCode; result.Title = order.Title; result.Duration = order.Duration; result.CourseFees = order.CourseFees; result.CGPA = order.CGPA;
            }
        }
        public static void Update(IEnumerable<Student> orders)
        {
            foreach (var order in orders)
            {
                Student result = GetAllRecords().Where(o => o.UniversityCode == order.UniversityCode).FirstOrDefault();
                if (result != null)
                {
                    result.UniversityCode = order.UniversityCode; result.Title = order.Title; result.Duration = order.Duration; result.CourseFees = order.CourseFees; result.CGPA = order.CGPA;
                }
            }
        }
    }
  #endregion
}
